<html>
<head>
	<meta http-equiv="content-type" content="text/html; charset=shift_jis">
</head>
<body>
<!-- #include file=UTF8Filer.asp -->
<%
' UTF8Filer Demo
' Written by Hunter Beanland
' http://www.geocities.com/hbeanland/
' hbeanland@yahoo.com.au

' UTF8Filer is a class which can read and write UTF-8 (Mixed Byte) files. Includes functions to convert to and from Unicode.
' ASP (pre .NET) does not support these files or text streams - only pure Single Byte and Unicode, so we need use this class to do some conversion first

'We must set ASP's codepage to shift-jis (# 932) so it knows what we are working with. Failure to set this correctly will show ??? instead of the chars.
'LCID is not required, but if you where playing in Japanese, it is better to set the LCID to Japan.
Session.CodePage = 932
'Session.LCID = &H0411

'Create an instance of the UTF8Filer class (included on line 3).
Dim MyUTF8File, HTMLHeader
Set MyUTF8File = New UTF8Filer

'We now set the class's charset to "shift_jis". This is a seperate setting to the CodePage above.
MyUTF8File.UnicodeCharset = "shift_jis"

'Open the Demo file with error checking
Response.Write("<font face='arial'><b>UTF-8 File Demo</b><p>")
Response.Write("NOTE: This demo uses Japanese (shift-jis) Character set. If this is not installed on your PC, then you will just see a jumble of Ascii characters (but the demo will work).<p>")
Response.Write("<b>Opening input UTF-8 Text (HTML) file:</b> demo.txt<p>")
if not MyUTF8File.LoadFile("Demo.txt") then
	'The filenames are stored here during the open process
	Response.Write(MyUTF8File.AbsoluteFileName & " (" & MyUTF8File.VirtualFileName & ")<br>")
	Response.Write(MyUTF8File.ErrorText & "<br>")
end if

'Convert the text from the file from UTF-8 to Unicode so ASP can deal with it
MyUTF8File.cTextBuffer2Unicode

'Display the contents on screen
'We can do it easier with this: Response.Write(MyUTF8File.TextBuffer)
'But I want to show off reading line by line (useful for reading structured data rather that whole files such as HTML files)
While not MyUTF8File.EOF
	Response.Write(MyUTF8File.ReadLine & vbLF)
Wend

'The data file we read in doesn't contain an HTML header - as we are displaying it in the body of this page, so let's add one so it can be viewed seperately.
HTMLHeader = "<html><head><meta http-equiv='content-type' content='text/html; charset=shift_jis'></head><body>"
MyUTF8File.TextBuffer =  HTMLHeader & MyUTF8File.TextBuffer

'Add an extra bit to the end using WriteLine
MyUTF8File.WriteLine "</body></html>"

'If you wanted to convert the TextBuffer back to UTF-8 you can just run the cUnicode2UTF8 method. Saving does this anyway, so no need to do it twice.
'MyUTF8File.cUnicode2UTF8

'Save it now.
Response.Write("<b>Save output UTF-8 HTML file with an extra HTML header:</b> demo-output.htm<br>")
if not MyUTF8File.SaveFile("demo-output.htm") then
	'The filenames are stored here during the open process
	Response.Write(MyUTF8File.AbsoluteFileName & " (" & MyUTF8File.VirtualFileName & ")<br>")
	Response.Write(MyUTF8File.ErrorText & "<br>")
end if

set MyUTF8File = nothing

%>
</body>
</html>